import * as ts from 'typescript';
import { DependencyTree, FileToDeps, Path } from '../';
import { FileProcessor } from '../file_processor';
export declare class TypeScriptFileProcessor implements FileProcessor {
    private readonly rootDir;
    private static memoizerCacheId;
    protected readonly compilerOptions: ts.CompilerOptions;
    private reExt;
    private reRootDir;
    private resolveModuleName;
    constructor(rootDir: string);
    private static resolveModuleName;
    static isEntryPointFileName(file: string): boolean;
    static createTSSourceFile(filePath: Path, target?: ts.ScriptTarget): Promise<ts.SourceFile>;
    process(file: Path, contents: string, missing: FileToDeps, files: ReadonlyArray<Path>, dependencyTree: DependencyTree): Promise<Set<Path>>;
    match(file: Path): boolean;
    supportedFileTypes(): string[];
    /**
     * Extracts the TS compiler options from the {rootDir}
     */
    private getTsCompilerOptions;
    private static getEntryPointImport;
}
